if ((bonjour ~= nil) and (bonjour.VERSION >= 0x0002)) then
  bonjourRequestIP = {}

  if (wifi.sta.getip() == nil) then
    print("mDNS requires an ip address. Please connect to a station.")
  else
	  srv = net.createServer(net.UDP)
	  conn = net.createConnection(net.UDP, 0)
	  conn:connect(5353, "224.0.0.251")
	  srv:on("receive", 
		function (s, c)    
		  -- get requests from frame
		  requests, responses = bonjour:parse(c) 
		  if (requests ~= nil) then
			for index, request in pairs(requests) do
			  tmr.wdclr() ;
			  print("Request mDNS["..index.."]: "..request.name.."(Type: "..request.type..")")
			  if ((request.name:lower() == "esp-8266.local") and (request.type == bonjour.TYPE.A)) then
				conn:send (
				  bonjour:create_response({{name = request.name, type=bonjour.TYPE.A, class=1, ttl=64, ip=wifi.sta.getip()}})
				)
			  end
			end
		  end
		  if (responses ~= nil) then
			for index, response in pairs(responses) do
			  tmr.wdclr() ;
		  if (response.type == bonjour.TYPE.A) then
				if (bonjourRequestIP.Name ~= nil) then
					if (bonjourRequestIP.Name:lower() == response.name:lower()) then
					  bonjourRequestIP.IP = response.ip
					  bonjourRequestIP.Callback(response.ip)
					  bonjourRequestIP.Name = nil ;
					else
						print("Response mDNS["..index.."]: "..response.name.."(A: ip="..response.ip..")")
					end
				else
					print("Response mDNS["..index.."]: "..response.name.."(A: ip="..response.ip..")")
				end 
		  elseif (response.type == bonjour.TYPE.CNAME) then
				print("Response mDNS["..index.."]: "..response.name.."(CNAME: cname="..response.cname..")")
		  else
				print("Response mDNS["..index.."]: "..response.name.."(Type: "..response.type..")")	
		  end
			end
		  end
		end
	  )
	  srv:listen(5353)
	  net.multicastJoin(wifi.sta.getip(), "224.0.0.251")
	end
	
	function RequestBonjourIP(localname, callback)
	  bonjourRequestIP.Name = localname
	  bonjourRequestIP.Callback = callback
	  bonjourRequestIP.IP = ""
          bonjourRequestIP.Retry = 0
		bonjourRequestIP.Done = 0
		conn:send(bonjour:create_request({{name = bonjourRequestIP.Name, type = bonjour.TYPE.A, class=bonjour.CLASS.IN}}))
		tmr.alarm(0,300, 1, 
		  function()
			  if (bonjourRequestIP.IP == "") then
					if (bonjourRequestIP.Retry > 8) then
						bonjourRequestIP.Done = 1
						  bonjourRequestIP.Callback(nil)
						tmr.stop(0)
					end
				  conn:send(bonjour:create_request({{name = bonjourRequestIP.Name, type = bonjour.TYPE.A, class=bonjour.CLASS.IN}}))
					bonjourRequestIP.Retry = bonjourRequestIP.Retry + 1 ;
			  else
				  bonjourRequestIP.Done = 1
				end
		  end
		)
	end
	
else
  print("mDNS Server requires user module Bonjour v0.02 or higher.") ;
end
